﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Drawing;
using System.Text;
using System.IO;

namespace OperateWordPro.OperateWordDemo1
{
    public partial class OperateWord : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        #region 1.0-不通过模板输出word
        /// <summary>
        /// 输出数据到word（后台设置内容）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void CreateWordBehind_Click(object sender, EventArgs e)
        {
            HttpContext.Current.Response.Clear();
            HttpContext.Current.Response.Buffer = true;
            HttpContext.Current.Response.Charset = "";

            // 设置输出头
            HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment;filename=" + System.Web.HttpUtility.UrlEncode("CreateWord", System.Text.Encoding.UTF8) + ".doc");

            // 设置输出的编码格式
            HttpContext.Current.Response.ContentEncoding = System.Text.Encoding.Default;

            // Response.ContentType指定文件类型 可以为application/ms-excel || application/ms-word || application/ms-txt || application/ms-html
            // 因为是输出word 所以这里就指定为 application/ms-word
            HttpContext.Current.Response.ContentType = "application/ms-word";

            // 定义StringBuilder 把要输出的内容写到里面,并且可以设置字体、颜色、大小等...
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<div style='text-align:center;font-size:18px;font-weight:bold;'>导出数据到word</div>");
            sb.AppendLine("这是导出到word的数据<br />");
            sb.AppendLine("<span style='color:blue;'>这是导出到word的数据</span>");

            HttpContext.Current.Response.Output.Write(sb);
            HttpContext.Current.Response.Flush();
            HttpContext.Current.Response.End();
        }

        /// <summary>
        /// 输出数据到word（前台设置内容）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void CreateWordFront_Click(object sender, EventArgs e)
        {
            HttpContext.Current.Response.Clear();
            HttpContext.Current.Response.Buffer = true;
            HttpContext.Current.Response.Charset = "";

            // 设置输出头
            HttpContext.Current.Response.AddHeader("Content-Disposition", "attachment;filename=" + System.Web.HttpUtility.UrlEncode("CreateWord", System.Text.Encoding.UTF8) + ".doc");

            // 设置输出的编码格式
            HttpContext.Current.Response.ContentEncoding = System.Text.Encoding.Default;

            // Response.ContentType指定文件类型 可以为application/ms-excel || application/ms-word || application/ms-txt || application/ms-html
            // 因为是输出word 所以这里就指定为 application/ms-word
            HttpContext.Current.Response.ContentType = "application/ms-word";

            // 定义输出流，其信息也是存储在StringBuilder中的
            System.IO.StringWriter oStringWriter = new System.IO.StringWriter();

            // 定义一个服务器控件输出流（可以把前端渲染后的页面以流的形式输出）
            System.Web.UI.HtmlTextWriter oHtmlTextWriter = new System.Web.UI.HtmlTextWriter(oStringWriter);

            // 控制前端的样式 （HtmlTextWriterStyle 枚举用来控制 显示、字体、大小、颜色...）
            title.Style.Add(HtmlTextWriterStyle.Display, "none");

            // 这样会把前端的整个页面输出,由于有些其他元素不需要输出，所以注释
            //this.RenderControl(oHtmlTextWriter);

            // 指定我们前端标记要输出的容器，容器包含的内容都可以输出
            this.WordContent.RenderControl(oHtmlTextWriter);

            HttpContext.Current.Response.Output.Write(oStringWriter);
            HttpContext.Current.Response.Flush();
            HttpContext.Current.Response.End();
        } 
        #endregion

        #region 2.0-通过模板输出word
        /// <summary>
        /// 通过htm模板生成Word
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void CreateWordByHtmlTemplate_Click(object sender, EventArgs e)
        {
            // 获取模板的路径 通过ExprotToWord处理返回 字符串
            string strWord = DealTemplate(Server.MapPath("../Document/通知.html"));

            Response.ContentEncoding = System.Text.Encoding.Default;
            Response.ClearContent();
            Response.ClearHeaders();
            Response.AddHeader("content-disposition", "attachment;filename=合同.doc"); //必须的
            Response.AddHeader("Content-type", "application");
            Response.ContentType = "application/ms-html";
            Response.ContentEncoding = System.Text.Encoding.Default;

            Response.Write(strWord);
            Response.Flush();
            Response.Close();
        }

        /// <summary>
        /// 通过mht模板生成Word
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void CreateWordBymhtTemplate_Click(object sender, EventArgs e)
        {
            // 获取模板的路径 通过ExprotToWord处理返回 字符串
            string strWord = DealTemplate(Server.MapPath("../Document/通知2.mht"));

            Response.ContentEncoding = System.Text.Encoding.Default;
            Response.ClearContent();
            Response.ClearHeaders();
            Response.AddHeader("content-disposition", "attachment;filename=合同.doc"); //必须的
            Response.AddHeader("Content-type", "application");
            Response.ContentType = "application/ms-html";
            Response.ContentEncoding = System.Text.Encoding.Default;

            Response.Write(strWord);
            Response.Flush();
            Response.Close();
        }

        /// <summary>
        /// 处理模板 返回处理结果
        /// </summary>
        /// <param name="templatePath"></param>
        /// <returns></returns>
        public string DealTemplate(string templatePath)
        {
            StringBuilder sb = new StringBuilder(1024);

            // 读取文档内容并转换成流的形式 编码为默认编码
            StreamReader sr = new StreamReader(templatePath, Encoding.UTF8);

            // 将流转换成字符串加进StringBuilder中
            sb.Append(Encoding.Default.GetString(Encoding.Default.GetBytes(sr.ReadToEnd())));

            // 把文档中我们设置的标志位换成我们想要的内容
            sb.Replace("{name}", "张三");
            sb.Replace("{orderNumber}", "ooxx124512");
            sb.Replace("{tel}", "1383838383");

            return sb.ToString();
        } 
        #endregion
    }
}